#include "Middleman.h"
#include <Application.h>
#include <GroupLayout.h>
#include <InterfaceDefs.h>
#include <Rect.h>
#include <Window.h>
#include <StringView.h>
#include "../App.h"
#include <cstdio>
#include <format>
#include <gloox/gloox.h>
#include <gloox/jid.h>
#include <gloox/client.h>
#include <iostream>
#include <ostream>
#include <thread>

// Connection middleman window.
// This window, when called, automatically sets up a connection to the XMPP server.

Middleman::Middleman(const char* _jid, const char* password) 
	: 	BWindow(BRect(200,200,600,400), TITLE, B_TITLED_WINDOW, B_NOT_MINIMIZABLE | B_QUIT_ON_WINDOW_CLOSE)
{
	BGroupLayout *group = new BGroupLayout(B_VERTICAL);
	SetLayout(group);

	group->View()->AdoptSystemColors();

	group->AddView(new BStringView("label", "Placeholder label (connecting...)"));
	group->AddView(new BStringView("label", std::format("JID: {}\nPassword: {}", _jid, password).c_str()));

	auto lambda = [](Middleman *mm, const char *_jid, const char *password) {
		gloox::JID jid(std::format("{}/{}", _jid, appName));
		mm->client = new gloox::Client(jid, password);
		mm->client->registerConnectionListener(mm);
		mm->client->registerPresenceHandler(mm);
		mm->client->connect(true);
	};

	std::thread tobj(lambda, this, _jid, password);
	tobj.detach();
}

void Middleman::onDisconnect(gloox::ConnectionError err)
{
	std::cout << "err: " << err << std::endl;
};
void Middleman::handlePresence(const gloox::Presence &presence)
{
	std::cout << "meow 1";
};
bool Middleman::onTLSConnect(const gloox::CertInfo &info)
{
	std::cout << "meow 1";
	return true;
};
void Middleman::onConnect()
{
	std::cout << "meow 333";
};
